/*
 ============================================================================
 Project    : Parallel Genetic Algorithm for the SUPBR Problem
                (version with multiple populations)
 File       : GerarPopuInicial.c
 Author     : Lucas Silveira
                Group of Theory of Computation
                Universidade de Brasilia (UnB) - Brazil
 ============================================================================
 */

#include <stdio.h>
#include <stdlib.h>
#include <time.h>
#include <math.h>
#include "structs_ga.h"



void mostrar_poblacion(poblacion *pob, int tamanho){
    
    int i,j;
    //imprimir poblacion actual
    for(i=pob->basePoblacion; i<pob->topePoblacion; i++){
        printf("(%d): ",i);
        for(j=0; j<tamanho; j++){
            printf("%d, ", pob->cromosomas[i].genes[j]);
        }
        printf("\n");
    }
    
}

//o rank representa o processo
void CarregarPopInitial(int world_rank, float porcentaje_reemp,  float porcentaje_selec, poblacion *pob, permutacion *perm){
	int i, P, j=0, valor;
    int contador=0;
    FILE *arq;
    if (world_rank==0)
    {
        arq = fopen("P0", "r");   
    }

    else if (world_rank==1)
    {
        arq = fopen("P1", "r");   
    }


    else if (world_rank==2)
    {
        arq = fopen("P2", "r");   
    }
    else if (world_rank==3)
    {
        arq = fopen("P3", "r");   
    }
    else if (world_rank==4)
    {
        arq = fopen("P4", "r");   
    }

   else if (world_rank==5)
    {
        arq = fopen("P5", "r");   
    }

   else if (world_rank==6)
    {
        arq = fopen("P6", "r");   
    }

   else if (world_rank==7)
    {
        arq = fopen("P7", "r");   
    }

   else if (world_rank==8)
    {
        arq = fopen("P8", "r");   
    }

   else if (world_rank==9)
    {
        arq = fopen("P9", "r");   
    }

   else if (world_rank==10)
    {
        arq = fopen("P10", "r");   
    }

   else if (world_rank==11)
    {
        arq = fopen("P11", "r");   
    }

   else if (world_rank==12)
    {
        arq = fopen("P12", "r");   
    }

   else if (world_rank==13)
    {
        arq = fopen("P13", "r");   
    }

  else if (world_rank==14)
    {
        arq = fopen("P14", "r");   
    }

  else if (world_rank==15)
    {
        arq = fopen("P15", "r");   
    }

  else if (world_rank==16)
    {
        arq = fopen("P16", "r");   
    }

  else if (world_rank==17)
    {
        arq = fopen("P17", "r");   
    }
 
  else if (world_rank==18)
    {
        arq = fopen("P18", "r");   
    }

  else if (world_rank==19)
    {
        arq = fopen("P19", "r");   
    }

  else if (world_rank==20)
    {
        arq = fopen("P20", "r");   
    }

  else if (world_rank==21)
    {
        arq = fopen("P21", "r");   
    }

  else if (world_rank==22)
    {
        arq = fopen("P22", "r");   
    }

  else
    {
        arq = fopen("P23", "r");   
    }




    if(arq == NULL)
    {
        printf("Erro, nao foi possivel abrir o arquivo\n");
        exit(0);
    }
    else
    {
        fscanf(arq,"%d", &perm->tamanho);
        fscanf(arq,"%d", &pob->tamanhoPoblacion);//for each individual
        fscanf(arq,"%d", &P);// numero de processadores
        pob->basePoblacion = 0;
        pob->topePoblacion = pob->tamanhoPoblacion;
        pob->limiteSeleccion = pob->tamanhoPoblacion * porcentaje_selec;//limite de pob q seran "seleccionados" para crossover
        pob->baseReemplazo = pob->tamanhoPoblacion * porcentaje_reemp;//base de pob a partir de donde se hara el reemplazo
        
        pob->baseDescendencia = pob->tamanhoPoblacion;
        pob->topeDescendencia = pob->tamanhoPoblacion + pob->limiteSeleccion;
        pob->tamanhoTotal = pob->topeDescendencia;// tamanho total = poblacion + descendencia
        /*alocar memoria*/
        pob->cromosomas = malloc(pob->tamanhoTotal*sizeof(cromosoma)); //alocar memoria para poblacion total
        if (pob->cromosomas == NULL)
            printf("pob->cromosomas NULL en poblacion_inicial() \n");
        for(i=0;i<pob->tamanhoTotal;i++){
            pob->cromosomas[i].genes = malloc(perm->tamanho * sizeof(int));//alocar memoria para cada cromosoma
            if (pob->cromosomas[i].genes == NULL)
                printf("pob->cromosomas[i].genes NULL en poblacion_inicial() \n");
        }
        
        //Posicionar pra o processador pegar a sua populacao
        
        if (world_rank!=0 )
        {
                  
            while (1)
            {
                fscanf(arq,"%d", &valor);
                if (valor==999 )
                {
                    contador++;
                    if (contador==(world_rank))
                    {
                        
                        break;
                    }
                    


                }//elsend if

                //indica fim de arquivo
                else if (valor==9999 )
                {
                    
                    printf("Alerta ha algo errado com o mapeamento da populacao e processador no CarregarPopInitial\n" );
                    exit(0);

                }//end if
                else
                ;
            }


        }//end if
        fscanf(arq,"%d", &valor);
         while (j<pob->tamanhoPoblacion)
         {
             
             
             for (i=0; i<perm->tamanho; i++)
            {
                pob->cromosomas[j].genes[i] = valor;
                fscanf(arq,"%d", &valor);
            }//end for
             
            pob->cromosomas[j].tamanho = perm->tamanho;
             j++;
             
             //fim do bloco do processador
           //  fscanf(arq,"%d", &valor);
             if (valor==999 || valor==9999 )
             {
                 break;
             }//end if

            
         }//end while
        
        for(i=pob->baseDescendencia; i<pob->topeDescendencia; i++){
            pob->cromosomas[i].tamanho = perm->tamanho;
        }
         
         
       //  mostrar_poblacion(pob, perm->tamanho);
       
        
    }//else
    fclose(arq);
}








/*


//o rank tem que ser passado sempre acrescentado de um
void CarregarPopInitial(int world_rank, float porcentaje_reemp,  float porcentaje_selec, poblacion *pob, permutacion *perm){
    int i, P, j, valor;
    int contador=0;
    FILE *arq;
    
    arq = fopen("PopulationInitial", "r");
    if(arq == NULL)
        printf("Erro, nao foi possivel abrir o arquivo\n");
    else
    {
        fscanf(arq,"%d", &perm->tamanho);
        fscanf(arq,"%d", &pob->tamanhoPoblacion);
        fscanf(arq,"%d", &P);// numero de processadores
        pob->basePoblacion = 0;
        pob->topePoblacion = pob->tamanhoPoblacion;
        pob->limiteSeleccion = pob->tamanhoPoblacion * porcentaje_selec;//limite de pob q seran "seleccionados" para crossover
        pob->baseReemplazo = pob->tamanhoPoblacion * porcentaje_reemp;//base de pob a partir de donde se hara el reemplazo
        
        pob->baseDescendencia = pob->tamanhoPoblacion;
        pob->topeDescendencia = pob->tamanhoPoblacion + pob->limiteSeleccion;
        pob->tamanhoTotal = pob->topeDescendencia;// tamanho total = poblacion + descendencia
        //alocar memoria
        pob->cromosomas = malloc(pob->tamanhoTotal*sizeof(cromosoma)); //alocar memoria para poblacion total
        if (pob->cromosomas == NULL)
            printf("pob->cromosomas NULL en poblacion_inicial() \n");
        for(i=0;i<pob->tamanhoTotal;i++){
            pob->cromosomas[i].genes = malloc(perm->tamanho * sizeof(int));//alocar memoria para cada cromosoma
            if (pob->cromosomas[i].genes == NULL)
                printf("pob->cromosomas[i].genes NULL en poblacion_inicial() \n");
        }
        
        j=0;
         while (j<pob->tamanhoPoblacion)
         {
             
             if (contador>=((world_rank-1)*pob->tamanhoPoblacion) && contador< (world_rank*pob->tamanhoPoblacion) )
             {
                 for (i=0; i<perm->tamanho; i++)
                 {
                     if (fscanf(arq,"%d", &valor)!=EOF )
                     {
                         pob->cromosomas[j].genes[i] = valor;
                     }//end if
                     
                 }//end for
                 pob->cromosomas[j].tamanho = perm->tamanho;
                 j++;
                 contador++;
                 //break;
             }//end if
             else
             {
                 j=0;
                 for (i=0; i<perm->tamanho; i++)
                 {
                     if (fscanf(arq,"%d", &valor)==EOF )
                     {
         
                         printf("Erro em montar a populacao inicial \n ");
         
                     }//end if
         
                 }//end for
                 contador++;
             }//end else
         }//end while
        
        for(i=pob->baseDescendencia; i<pob->topeDescendencia; i++){
            pob->cromosomas[i].tamanho = perm->tamanho;
        }
         
         
        // mostrar_poblacion(pob, n);
       
        
      }//else
    fclose(arq);
}


*/












int  leer_permutacion_de_archivo(char* nombre_archivo, permutacion *perm){
    int i,n;
    n=0;
    FILE *filePointer;
    if ((filePointer = fopen(nombre_archivo,"r")) == NULL){
        printf("Input file could not be opened\n");
    }
    else
    {
        fscanf(filePointer,"%d",&n);//leer tamanho de permutacion
        perm->tamanho = n;    
        for(i=0; i<n; i++)
            fscanf(filePointer,"%d",&perm->pi[i]);

        
    }
    fclose(filePointer);

    
    
    return n;

}



//processo de debug
//Passa a quantidade de processadores a ser utilizado
void construirPopInit(int P, int rank){
    int i, j, n, prob;
    permutacion perm;
    FILE *fp;
    int flag=999; //indica o final de uma linha
    int flag2=9999;//indica o final do arquivo
    int conta_blocos=0;
    n=leer_permutacion_de_archivo("i", &perm);
   
   
    int tamanhoPop=(int) (n * (log(n) / log(2))); //tamanho de la poblacion = (nlogn), log base 2
    tamanhoPop=tamanhoPop*P;
     //printf ("qual tamanho da populacao %d \n", tamanhoPop);
//printf ("qual tamanho da populacao x %d \n", (int )(n * (log(n) / log(2)))  );
    
	if(rank==0)
	{
		fp = fopen("P0", "w");
	}


	else if(rank==1)
	{
		fp = fopen("P1", "w");
	}
	
	else if(rank==2)
	{
		fp = fopen("P2", "w");
	}

	else if (rank==3)
	{
		fp = fopen("P3", "w");
	}

	else if (rank==4)
	{
		fp = fopen("P4", "w");
	}
	
	else if (rank==5)
	{
		fp = fopen("P5", "w");
	}
	
	else if (rank==6)
	{
		fp = fopen("P6", "w");
	}

	else if (rank==7)
	{
		fp = fopen("P7", "w");
	}


	else if (rank==8)
	{
		fp = fopen("P8", "w");
	}
	
	else if (rank == 9)
	{
		fp = fopen("P9", "w");

	}

	else if (rank == 10)
	{
		fp = fopen("P10", "w");
	}

	else if (rank == 11)
	{
		fp = fopen("P11", "w");
	}

	else if (rank == 12 )
	{
		fp = fopen("P12", "w");
	}

	else if (rank == 13)
	{
		fp = fopen("P13", "w");
	}


	else if (rank == 14)
	{
		fp = fopen("P14", "w");
	}

	else if (rank == 15)
	{
		fp = fopen("P15", "w");
	}

	else if (rank == 16)
	{
		fp = fopen("P16", "w");
	}
	
	else if (rank == 17)
	{
		fp = fopen("P17", "w");	
	}

	else if (rank == 18)
	{
		fp = fopen("P18", "w");
	}

	else if (rank == 19)
	{
		fp = fopen("P19", "w");
	}


	else if (rank == 20)
	{
		fp = fopen("P20", "w");
	}

	else if (rank == 21)
	{
		fp = fopen("P21", "w");
	}

	else if (rank == 22)
	{
		fp = fopen("P22", "w");
	}
	else
	{
		fp = fopen("P23", "w");
	}




	if (fp != NULL)
    {
        fprintf(fp,"%d\n",perm.tamanho);// tamanho da permutacao
        fprintf(fp,"%d\n",((int)(n * (log(n) / log(2)))));// tamanho da populacao
        fprintf(fp,"%d\n",P);// qtd de  processadores
        for(i=0; i < tamanhoPop; i++)
        {
            for(j = 0; j < perm.tamanho; j++)
            {
                prob = rand() % 2;//valores entre 0 y 1
                if (prob == 1)//si prob 1, entonces gen positivo
                {
                    
                        fprintf(fp,"%d\n",perm.pi[j]);
                    
                }
                else//si prob 0, entonces gen negativo
                {
                    
                        fprintf(fp,"%d\n",(perm.pi[j] * -1));
                    
                }
            }//end for j
            
            
            
            conta_blocos++;
            
            
            //signifca q tenho um bloco fechado
            if (conta_blocos==((int)(n * (log(n) / log(2))))) {
                if (i<(tamanhoPop-1))
                {
                    fprintf(fp,"%d\n",flag); //mostrando que aqui acaba o individuo
                }
                else
                fprintf(fp,"%d\n",flag2); //mostrando que aqui acaba o arquivo
                
                
                conta_blocos=0;
            }
            
            
            
                
        }//end for i
        fclose(fp);
    }//end if
    
    else
    {
        printf("Falha ao criar o Arquivo");
        exit(1);
    }

        
        
    
}






/*Passa a quantidade de processadores a ser utilizado
void construirPopInit(int P){
    int i, j, n, prob;
    permutacion perm;
    FILE *fp;
    n=leer_permutacion_de_archivo("i", &perm);
    
    int tamanhoPop=(int) (P* (n * (log(n) / log(2)))); //tamanho de la poblacion = (nlogn), log base 2
    //crear poblacion a partir de permutacion
        if ((fp = fopen("PopulationInitial", "w")) != NULL)
        {
            fprintf(fp,"%d\n",perm.tamanho);// tamanho da permutacao
            fprintf(fp,"%d\n",((int)(n * (log(n) / log(2)))));// tamanho da populacao
            fprintf(fp,"%d\n",P);// qtd de  processadores
            for(i=0; i < tamanhoPop; i++)
            {
                for(j = 0; j < perm.tamanho; j++){
                    prob = rand() % 2;//valores entre 0 y 1
                    if (prob == 1)//si prob 1, entonces gen positivo
                    {
                        if (i!=tamanhoPop-1 || j!=perm.tamanho-1)
                            fprintf(fp,"%d\n",perm.pi[j]);
                        else
                            fprintf(fp,"%d",perm.pi[j]);
                    }
                    else//si prob 0, entonces gen negativo
                    {
                        if (i!=tamanhoPop-1 || j!=perm.tamanho-1)
                            fprintf(fp,"%d\n",(perm.pi[j] * -1));
                        else
                            fprintf(fp,"%d",perm.pi[j]);
                    }
                }//end for j
                
            }//end for i
        }//end if
    
        else{
            printf("Falha ao criar o Arquivo");
            exit(1);
        }
        fclose(fp);
        
    
}*/



/*

int main(int argc,char **argv)
{
    int seed2=atoi(argv[1]);
    //int numeroProcessadores=atoi(argv[2]);
    srand (seed2);//initialize random generator
    
    construirPopInit(4, 2);
    poblacion pob;
    permutacion perm;
    leer_permutacion_de_archivo("i", &perm);
   CarregarPopInitial(2, 0.5, 0.8, &pob,&perm);
    return 0;
}
 

*/